module MtrMonitor
  module Cleaner

    MAX_AGE = 2 * 7 * 24 * 60 * 60 # two weeks

    def self.execute(logger)
      logger.info("[CLEANER] Deleting reports created more than 2 weeks ago")

      old_reports.each do |filename|
        logger.info("Deleting #{filename}")
        `sudo rm -f #{filename}`
      end

      logger.info("[CLEANER] Done.")
    end

    def self.old_reports
      all_reports.select do |filename|
        File.mtime(filename) < (Time.now - MAX_AGE)
      end
    end

    def self.all_reports
      Dir.glob("#{MtrMonitor::LOCAL_REPORTS_DIR}/*")
    end

  end
end
